PDA

Archiv verlassen und diese Seite im Standarddesign anzeigen : SystemV und VNCserver



deac
25.12.01, 20:50
hier für leute, die es brauchen könnten:


#!/bin/bash
# Copyright (c) 2001 Denis Knauf
#
# Author: Denis Knauf <deac@netcologne.de>
#
# init.d/vncserver
#
# and symbolic its link
#
# /sbin/rcvncserver
#
# System startup script for the nessus backend nessusd
#
### BEGIN INIT INFO
# Provides: vncserver
# Required-Start: $remote_fs $syslog
# Required-Stop: $remote_fs $syslog
# Default-Start: 3 5
# Default-Stop: 0 1 2 6
# Description: Start vncserver to allow remotecontrol by X.
### END INIT INFO

# Source SuSE config
. /etc/rc.config

# Determine the base and follow a runlevel link name.
base=${0##*/}
link=${base#*[SK][0-9][0-9]}

# Force execution if not called by a runlevel directory.
test $link = $base && START_VNCSERVER=yes
test "$START_VNCSERVER" = yes || exit 0

VNCSERVER_BIN=/usr/bin/Xvnc
test -x $VNCSERVER_BIN || exit 5

# Shell functions sourced from /etc/rc.status:
# rc_check check and set local and overall rc status
# rc_status check and set local and overall rc status
# rc_status -v ditto but be verbose in local rc status
# rc_status -v -r ditto and clear the local rc status
# rc_failed set local and overall rc status to failed
# rc_reset clear local rc status (overall remains)
# rc_exit exit appropriate to overall rc status
. /etc/rc.status

# First reset status of this service
rc_reset

# Return values acc. to LSB for all commands but status:
# 0 - success
# 1 - misc error
# 2 - invalid or excess args
# 3 - unimplemented feature (e.g. reload)
# 4 - insufficient privilege
# 5 - program not installed
# 6 - program not configured
# 7 - program is not running
#
# Note that starting an already running service, stopping
# or restarting a not-running service as well as the restart
# with force-reload (in case signalling is not supported) are
# considered a success.

case "$1" in
start)
echo -n "Starting vncserver"
## Start daemon with startproc(8). If this fails
## the echo return value is set appropriate.

# startproc should return 0, even if service is
# already running to match LSB spec.
su vnc -c "/usr/bin/vncserver $VNCSERVER_PARAM"

# Remember status and be verbose
rc_status -v
;;
stop)
echo -n "Shutting down vncserver"
## Stop daemon with killproc(8) and if this fails
## set echo the echo return value.

killproc $VNCSERVER_BIN

# Remember status and be verbose
rc_status -v
;;
try-restart)
## Stop the service and if this succeeds (i.e. the
## service was running before), start it again.
$0 stop && $0 start

# Remember status and be quiet
rc_status
;;
restart)
## Stop the service and regardless of whether it was
## running or not, start it again.
$0 stop
$0 start

# Remember status and be quiet
rc_status
;;
force-reload)
$0 restart
## Signal the daemon to reload its config. Most daemons
## do this on signal 1 (SIGHUP).
## If it does not support it, restart.

echo -n "Reload service vncserver"
## if it supports it:
killproc -HUP $VNCSERVER_BIN
#touch /var/run/FOO.pid
rc_status -v

## Otherwise:
#$0 stop && $0 start
#rc_status

;;
reload)
## Like force-reload, but if daemon does not support
## signalling, do nothing (!)

# If it supports signalling:
echo -n "Reload service vncserver"
killproc -HUP $VNCSERVER_BIN
#touch /var/run/FOO.pid
rc_status -v

# If it does not support reload:
#exit 3
;;
status)
echo -n "Checking for vncserver: "
## Check status with checkproc(8), if process is running
## checkproc will return with exit status 0.

# Status has a slightly different for the status command:
# 0 - service running
# 1 - service dead, but /var/run/ pid file exists
# 2 - service dead, but /var/lock/ lock file exists
# 3 - service not running

# If checkproc would return LSB compliant ret values,
# things could be a little bit easier here. This will
# probably soon be the case ...
checkproc $VNCSERVER_BIN; rc=$?
if test $rc = 0; then echo "OK"
else
echo "No process"
if test -e /var/run/Xvnc.pid;
then exit 1
else exit 3
fi
fi
#rc_status
;;
# probe)
# ## Optional: Probe for the necessity of a reload,
# ## give out the argument which is required for a reload.
#
# test /etc/FOO/FOO.conf -nt /var/run/FOO.pid && echo reload
# ;;
*)
echo "Usage: $0 {start|stop|status|try-restart|restart|force-reload|reload}"
exit 1
;;
esac
rc_exit

dieses script wird zu den SystemV-Prozessen hinzu gefügt und startet den server von vnc beim starten.

kleine vorarbeiten:
der benutzer vnc muss existieren.
rc.config anpassen.

das script wird noch bearbeitet und das perlscript vncserver soll überflüssig werden. stattdessen soll direkt Xvnc benutzt werden.

nur für suselinux, kann aber auch unter anderen probiert werden.

für jede kleine verbesserung wäre ich dankbar und auch für hilfe beim perlscript vncserver enziffern ebenfalls. ich kann noch kein perl.

deac
02.02.02, 20:41
Dieses Script hier zu posten war die genialste Idee, die ich mir vorstellen kann.:D
Bin ich froh.
Das Script müsste ich sonst nochmal schreiben, da es verloren ging.

Bin ich genial.:D:D